<template>
  <div>
    <UpsertContact v-model="showCreateContactModal" :user="currentEdit" @closeEdit="clearEdit" />
    <Modal v-model="showDeleteContactModal" title="Excluir contato">
      <p>Deseja realmente excluir o contato?</p>
      <template v-slot:footer>
        <Button
          class="link"
          @click="
            showDeleteContactModal = false;
            currentDelete = null;
          "
          >Cancelar
        </Button>
        <Button class="primary" @click="deleteContact()">Excluir</Button>
      </template>
    </Modal>
    <div class="wrapper" v-if="!hasContacts">
      <img src="@/assets/images/book.svg" alt="Book" />
      <p>Nenhum contato foi criado ainda.</p>
      <Button @click="showCreateContactModal = true">
        <img src="@/assets/icons/ic-plus.svg" alt="ADD Icon" />
        Criar contato
      </Button>
    </div>

    <div v-else-if="contacts.length > 0" class="list-contacts">
      <table>
        <thead>
          <th></th>
          <th>Contatos</th>
          <th>E-mail</th>
          <th>Telefone</th>
          <th></th>
        </thead>
        <tbody>
          <tr v-for="item in contacts" :key="item.id" :class="{ highlight: +new Date() - item.createdAt < 10000 }">
            <td>
              <div class="contact-image" :style="{ background: item.bg }">
                {{ getFirstLetter(item.name) }}
              </div>
            </td>
            <td>{{ item.name }}</td>
            <td>{{ item.email }}</td>
            <td>{{ item.phone }}</td>
            <td>
              <img @click="edit({ ...item })" src="@/assets/icons/ic-edit.svg" alt="Edit Icon" />
              <img @click="openDeleteModal(item.id)" src="@/assets/icons/ic-delete.svg" alt="Delete Icon" />
            </td>
          </tr>
        </tbody>
      </table>
    </div>

    <div v-else-if="contacts.length < 1" class="not-found">Nenhum contato encontrado!</div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, reactive, Ref, ref } from '@vue/composition-api';
import { Button, Modal } from '@/components';
import { UpsertContact } from '@/containers';
import { useStore } from '@/store';
import { Contact } from '@/store/modules/contacts/types';

export default defineComponent({
  name: 'ListContacts',
  components: {
    Button,
    Modal,
    UpsertContact,
  },
  setup() {
    const { getters, dispatch } = useStore();

    const initialState = {
      edit: {
        name: '',
        email: '',
        phone: '',
        id: null,
      },
    };

    const showCreateContactModal = ref(false);
    const showDeleteContactModal = ref(false);
    const currentDelete: Ref<null | number> = ref(null);
    const hasContacts = computed(() => getters.hasContacts);
    const contacts = computed(() => getters.getContacts);
    let currentEdit = (reactive({ ...initialState.edit }) as unknown) as {
      name: string;
      email: string;
      phone: string;
      id: number;
    };

    const edit = ({ name, email, phone, id }: Pick<Contact, 'name' | 'email' | 'phone' | 'id'>) => {
      Object.assign(currentEdit, {
        name,
        email,
        phone,
        id,
      });
      showCreateContactModal.value = true;
    };

    const clearEdit = () => {
      Object.assign(currentEdit, initialState.edit);
    };

    const getFirstLetter = (text: string) => {
      return [...text][0].toUpperCase();
    };

    const openDeleteModal = (id: number) => {
      showDeleteContactModal.value = true;
      currentDelete.value = id;
    };

    const deleteContact = () => {
      dispatch('deleteContact', currentDelete.value);
      currentDelete.value = null;
      showDeleteContactModal.value = false;
    };

    return {
      showCreateContactModal,
      hasContacts,
      contacts,
      currentEdit,
      edit,
      clearEdit,
      getFirstLetter,
      showDeleteContactModal,
      currentDelete,
      deleteContact,
      openDeleteModal,
    };
  },
});
</script>

<style lang="scss" scoped>
@import './ListContacts.scss';
</style>
